| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
SoGLViewingMatrixElement Class Reference
Element Classes

The SoGLViewingMatrixElement class is used to store the current viewing matrix.The viewing matrix contains the inverse camera coordinate system matrix. The camera coordinate system is built from the field values in the current SoCamera (currently either SoPerspectiveCamera or SoOrthographicCamera) and any transformations prior to the camera in the scene graph. More...

`#include <Inventor/elements/SoGLViewingMatrixElement.h>`

Inheritance diagram for SoGLViewingMatrixElement:

## Public Member Functions

virtual void | init (SoState *state)
| FIXME: write doc.
virtual void | push (SoState *state)
virtual void | pop (SoState *state, const SoElement *prevTopElement)

## Static Public Member Functions

static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static uint32_t | getNodeId (SoState *const state)
static SbMatrix | getResetMatrix (SoState *state)
Static Public Member Functions inherited from SoViewingMatrixElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | set (SoState *const state, SoNode *const node, const SbMatrix &ViewingMatrix)
| FIXME: write doc.
static const SbMatrix & | get (SoState *const state)
| FIXME: write doc.
Static Public Member Functions inherited from SoReplacedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions

virtual | ~SoGLViewingMatrixElement ()
virtual void | setElt (const SbMatrix &matrix)
Protected Member Functions inherited from SoViewingMatrixElement
virtual | ~SoViewingMatrixElement ()
Protected Member Functions inherited from SoReplacedElement
virtual | ~SoReplacedElement ()
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members

Static Protected Member Functions inherited from SoReplacedElement
static SoElement * | getElement (SoState *const state, const int stackIndex, SoNode *const node)
Protected Attributes inherited from SoViewingMatrixElement
SbMatrix | viewingMatrix
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoGLViewingMatrixElement class is used to store the current viewing matrix.

The viewing matrix contains the inverse camera coordinate system matrix. The camera coordinate system is built from the field values in the current SoCamera (currently either SoPerspectiveCamera or SoOrthographicCamera) and any transformations prior to the camera in the scene graph.

## Constructor & Destructor Documentation

SoGLViewingMatrixElement::~SoGLViewingMatrixElement | ( | void | ) |  |

protectedvirtual

The destructor.

## Member Function Documentation

void * SoGLViewingMatrixElement::createInstance | ( | void | ) |  |

static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

void SoGLViewingMatrixElement::push | ( | SoState * | state) |  |

virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoElement.

void SoGLViewingMatrixElement::pop | ( | SoState * | state,
|  | const SoElement * | prevTopElement
| ) |  |

virtual

This method is callled when the state is popped, and the depth of the element is bigger than the current state depth. pop() is called on the new top of stack, and a pointer to the previous top of stack is passed in prevTopElement.

Override this method if you need to copy some state information from the previous top of stack.

Reimplemented from SoElement.

uint32_t SoGLViewingMatrixElement::getNodeId | ( | SoState *const | state) |  |

static

Returns the node id of the current camera node. This is used by SoGLModelMatrixElement to detect a change in the viewing matrix inside an SoTransformSeparator node.

SbMatrix SoGLViewingMatrixElement::getResetMatrix | ( | SoState * | state) |  |

static

Returns the matrix that should be used by SoGLModelMatrixElement when the transformation should be reset during traversal (typically when encountering an SoResetTransform node). It is not sufficient to simply load the viewing matrix, since the transformations that were applied before the camera needs to be accounted for.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 2.0

void SoGLViewingMatrixElement::setElt | ( | const SbMatrix & | matrix) |  |

protectedvirtual

Sets the current viewing matrix.

Reimplemented from SoViewingMatrixElement.

The documentation for this class was generated from the following files:

- SoGLViewingMatrixElement.h
- SoGLViewingMatrixElement.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.